## ktactilefeedback 1.0.0~git20250725.da7858a

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(KTACTILE_FEEDBACK_VERSION "1.0.0") # handled by release scripts
project(KTactileFeedback VERSION ${KTACTILE_FEEDBACK_VERSION})

# ECM setup
include(FeatureSummary)
set(QT_MAJOR_VERSION 6)
find_package(ECM "5.11.0" NO_MODULE)
set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEGitCommitHooks)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMGenerateExportHeader)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMAddQch)
include(ECMAddTests)
include(ECMQtDeclareLoggingCategory)

# Dependencies
set(REQUIRED_QT_VERSION 6.4.0)

find_package(Qt6 ${REQUIRED_QT_VERSION} REQUIRED CONFIG COMPONENTS Core Qml Multimedia)

set(EXCLUDE_DEPRECATED_BEFORE_AND_AT 0 CACHE STRING "Control the range of deprecated API excluded from the build [default=0].")

option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
add_feature_info(QCH ${BUILD_QCH} "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")
option(ENABLE_QTMULTIMEDIA_BACKEND "Build the QtMultimedia backend" ON)
option(BUILD_TESTING "Build tests" ON)

add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050f00)
add_definitions(-DQT_NO_FOREACH)

add_subdirectory(src)
if (BUILD_TESTING)
    add_subdirectory(autotests)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== autotests/CMakeLists.txt ===
find_package(Qt6Test REQUIRED)

add_subdirectory(qfeedbackactuator)
add_subdirectory(qfeedbackhapticseffect)
add_subdirectory(qdeclarativefeedback)
if (TARGET QtFeedbackMMK)
    add_subdirectory(qfeedbackmmk)
endif()

=== src/CMakeLists.txt ===
add_subdirectory(feedback)
add_subdirectory(imports)
add_subdirectory(plugins)

=== autotests/cmake/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)

project(qmake_cmake_files)

enable_testing()

find_package(Qt6Core REQUIRED)

include("${_Qt6CTestMacros}")

expect_pass(test_modules)

=== autotests/qdeclarativefeedback/CMakeLists.txt ===
ecm_add_test(tst_qdeclarativefeedback.cpp LINK_LIBRARIES KTactileFeedback Qt::Test Qt::Qml TEST_NAME qdeclarativefeedback)
target_compile_definitions(qdeclarativefeedback PRIVATE -DSRCDIR="${CMAKE_CURRENT_SOURCE_DIR}")

=== autotests/qfeedbackactuator/CMakeLists.txt ===
ecm_add_test(tst_qfeedbackactuator.cpp LINK_LIBRARIES KTactileFeedback Qt::Test TEST_NAME qfeedbackactuator)

=== autotests/qfeedbackhapticseffect/CMakeLists.txt ===
ecm_add_test(tst_qfeedbackhapticseffect.cpp LINK_LIBRARIES KTactileFeedback Qt::Test TEST_NAME qfeedbackhapticseffect)

=== autotests/qfeedbackmmk/CMakeLists.txt ===
ecm_add_test(tst_qfeedbackmmk.cpp LINK_LIBRARIES KTactileFeedback QtFeedbackMMK Qt::Test TEST_NAME qfeedbackmmk)
target_compile_definitions(qfeedbackmmk PRIVATE -DSRCDIR="${CMAKE_CURRENT_SOURCE_DIR}/")

=== src/feedback/CMakeLists.txt ===
add_library(KTactileFeedback SHARED
    qfeedbackeffect.h
    qfeedbackglobal.h
    qfeedbackpluginsearch.h
    qfeedbackplugin.cpp
    qfeedbackeffect_p.h
    qfeedbackeffect.cpp
    qfeedbackactuator.cpp
    qfeedbackplugininterfaces.h
    qfeedbackplugin_p.h
    qfeedbackactuator.h)

add_library(KTactileFeedback::KTactileFeedback ALIAS KTactileFeedback)

target_link_libraries(KTactileFeedback PUBLIC Qt6::Core)

set_target_properties(KTactileFeedback PROPERTIES
    VERSION     ${KTACTILE_FEEDBACK_VERSION}
    SOVERSION   1
    EXPORT_NAME "KTactileFeedback"
)

ecm_generate_export_header(KTactileFeedback
    VERSION ${KTACTILE_FEEDBACK_VERSION}
    BASE_NAME KTactileFeedback
)

ecm_generate_headers(KFeedback_HEADERS
    HEADER_NAMES
    QFeedbackActuator
    QFeedbackEffect
    QFeedbackGlobal
    QFeedbackPluginInterfaces
    QFeedbackPluginSearch

    REQUIRED_HEADERS KFeedback_HEADERS
)

install(FILES ${KFeedback_HEADERS}
        DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KTactileFeedback
        COMPONENT Devel)

install(TARGETS KTactileFeedback
        EXPORT KTactileFeedbackTargets
        ${KF6_INSTALL_TARGETS_DEFAULT_ARGS})

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KTactileFeedback")

ecm_setup_version(
  PROJECT
  VARIABLE_PREFIX KTactileFeedback
  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kfeedback_version.h"
  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KTactileFeedbackConfigVersion.cmake"
  SOVERSION 1)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KTactileFeedbackConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KTactileFeedbackConfig.cmake"
    INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
    PATH_VARS  CMAKE_INSTALL_PREFIX
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KTactileFeedbackConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KTactileFeedbackConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

install(EXPORT KTactileFeedbackTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE KTactileFeedbackTargets.cmake
    NAMESPACE KTactileFeedback::
)

=== src/imports/CMakeLists.txt ===
add_library(declarative_feedback SHARED
    feedback/qdeclarativefileeffect_p.h
    feedback/qdeclarativefeedbackeffect.cpp
    feedback/qdeclarativefeedbackeffect_p.h
    feedback/qdeclarativethemeeffect.cpp
    feedback/qdeclarativefeedbackactuator.cpp
    feedback/qdeclarativefileeffect.cpp
    feedback/qdeclarativethemeeffect_p.h
    feedback/qdeclarativefeedbackactuator_p.h
    feedback/qdeclarativehapticseffect.cpp
    feedback/plugin.cpp
    feedback/qdeclarativehapticseffect_p.h)

target_link_libraries(declarative_feedback PUBLIC Qt::Core Qt::Qml KTactileFeedback)
install(TARGETS declarative_feedback DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/tactilefeedback)
install(FILES feedback/plugins.qmltypes feedback/qmldir DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/tactilefeedback)

=== src/plugins/CMakeLists.txt ===
if (ENABLE_QTMULTIMEDIA_BACKEND)
    add_subdirectory(feedback/mmk)
endif()
add_subdirectory(feedback/hfd-service)
add_subdirectory(feedback/feedbackd)

=== autotests/cmake/test_modules/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)

project(test_modules)

find_package(Qt5Core REQUIRED)

find_package(Qt5Feedback REQUIRED)

include_directories(
  ${Qt5Feedback_INCLUDE_DIRS}
)

add_definitions(
  ${Qt5Feedback_DEFINITIONS}
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")

add_executable(mainapp main.cpp)
target_link_libraries(mainapp
  ${Qt5Feedback_LIBRARIES}
)

## ktactilefeedback 0.0.0+p24.04+vunstable+git20251202.0950

=== debian/changelog ===
ktactilefeedback (0.0.0+p24.04+vunstable+git20251202.0950-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 02 Dec 2025 09:50:45 +0000

ktactilefeedback (0.0.0-0neon) noble; urgency=medium

  * Initial packaging

 -- Neon CI <neon@kde.org>  Sun, 13 Jul 2025 16:44:11 +1000

=== debian/control ===
Source: ktactilefeedback
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               kf6-extra-cmake-modules,
               pkg-kde-tools-neon,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-multimedia-dev
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/plasma/ktactilefeedback
Rules-Requires-Root: no
Vcs-Git: https://invent.kde.org/neon/neon-packaging/ktactilefeedback.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/ktactilefeedback
Maintainer: Neon CI <neon@kde.org>

Package: ktactilefeedback
Architecture: any
Depends: feedbackd-device-themes, ${misc:Depends}, ${shlibs:Depends}
Description: KDE tactile feedback provider library
 work in progress repository for working on QtFeedback patches.
 .
 This package contains the ktactilefeedback main library.

Package: ktactilefeedback-dev
Section: libdevel
Architecture: any
Depends: kf6-extra-cmake-modules,
         ktactilefeedback (= ${binary:Version}),
         qt6-base-dev,
         ${misc:Depends}
Description: KDE tactile feedback provider library
 work in progress repository for working on QtFeedback patches.
 .
 This package contains the ktactilefeedback development files.

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_QCH=ON

override_dh_auto_test:
	#do not run tests
	true

## ktactilefeedback 1.0.0~git20250725.da7858a

=== debian/changelog ===
ktactilefeedback (1.0.0~git20250725.da7858a-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1115608).

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 18 Sep 2025 23:07:39 +0200

=== debian/control ===
Source: ktactilefeedback
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               extra-cmake-modules,
               libpulse-dev,
               pkg-kde-tools,
               qt6-base-dev,
               qt6-declarative-dev,
               qml6-module-qtquick,
               qml6-module-qtqml-workerscript,
               qt6-multimedia-dev,
               qt6-tools-dev,
               xauth,
               xvfb,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://invent.kde.org/jbbgameich/ktactilefeedback
Vcs-Git: https://gitlab.com/ubports/development/core/packaging/ktactilefeedback.git
Vcs-Browser: https://gitlab.com/ubports/development/core/packaging/ktactilefeedback

Package: libktactilefeedback1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Tactile feedback library for Qt
 KTactileFeedback provides a C++ API as well as a QML module which use
 pluggable backends in order to provide tactile and audio feedback to the user.
 .
 This package provides the Qt API as well as the backend plugins.

Package: qml6-module-ktactilefeedback
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libktactilefeedback1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Tactile feedback QML module
 KTactileFeedback provides a C++ API as well as a QML module which use
 pluggable backends in order to provide tactile and audio feedback to the user.
 .
 This package contains the QML module.

Package: ktactilefeedback-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libktactilefeedback1 (= ${binary:Version}), qt6-base-dev, ${misc:Depends}
Description: KTactileFeedback development files
 KTactileFeedback provides a C++ API as well as a QML module which use
 pluggable backends in order to provide tactile and audio feedback to the user.
 .
 This package contains the header development files used for building Qt
 applications using tactile feedback API.

Package: ktactilefeedback-examples
Architecture: all
Section: libdevel
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
Description: KTactileFeedback QML examples
 KTactileFeedback provides a C++ API as well as a QML module which use
 pluggable backends in order to provide tactile and audio feedback to the user.
 .
 This package contains the examples for using the tactile feedback API.

Package: ktactilefeedback-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: KTactileFeedback documentation
 KTactileFeedback provides a C++ API as well as a QML module which use
 pluggable backends in order to provide tactile and audio feedback to the user.
 .
 This package contains the documentation for the tactile feedback C++ API and
 QML module.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_QCH=ON

override_dh_auto_test:
	# temporarily ignore test results, qdeclarativefeedback fails if the
	# QML module is not installed
	-dh_auto_test

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=1.0.0~git%cd.%h" \
https://invent.kde.org/jbbgameich/ktactilefeedback \
heads/master debian
